import subprocess
import time
import sys
import re
import os
import signal
from Adafruit_CharLCDPlate_2 import Adafruit_CharLCDPlate

print sys.argv
Address = int("0x"+sys.argv[2], 16)

Lcd = Adafruit_CharLCDPlate(addr=Address)
Lcd.begin(20, 4)
Lcd.backlight(Lcd.RED)

Delay = 300
News = []
Feed = 'feeds.bbci.co.uk/news/rss.xml?edition=uk'

def handler(signal, frame):
	sys.exit(0)


signal.signal(signal.SIGINT, handler)

def Update_News(Url):
	News = []
	Args = ['curl' , Url]
	Proc = subprocess.Popen(Args, stdout=subprocess.PIPE)
	Out = Proc.stdout.read()
	Title = re.findall('<title>([\S ]*)</title>', Out)
	Title.pop(0)
	Title.pop(0)

	for A in Title:
		if A[:6] == 'VIDEO:' or A[:6] == 'AUDIO:' or A[:12] == 'In pictures:' or A[:16] == 'Day in pictures:':
			A = ''
		else:
			News.append(A)

	return News

def Output_RSS():
	News = Update_News(Feed)
	Shift = 0
	Max = 0
	Line1 = News[0]
	Line2 = News[1]
	Line3 = News[2]
	if len(Line2) > len(Line1):
		Max = len(Line2)
	elif len(Line3) > len(Line2):
		Max = len(Line3)
	elif len(Line1) > len(Line3):
		Max = len(Line1)

	print Line1, "\n", Line2, "\n", Line3, "\n"
	Day = time.strftime('%d')
	Suf = "th"
	if Day == "01" or Day == "21" or Day == "31":
		Suf = "st"
	elif Day == "02" or Day == "22":
		Suf = "nd"
	elif Day == "03" or Day == "23":
		Suf = "rd"
	else:
		Suf = "th"
	if int(Day) < 10:
		Day = str(Day)[1:]
	Date =  time.strftime("{0}{1} %b, %H:%M".format(Day, Suf))
	while Shift < Max:
		try:
			Lcd.backlight(Lcd.RED)
			Lcd.clear()
			Lcd.setCursor(0,0)
			Lcd.message(Date)
			News1 = Line1[Shift:Shift+20]
			News2 = Line2[Shift:Shift+20]
			News3 = Line3[Shift:Shift+20]
			Lcd.setCursor(0,1)
			Lcd.message(News1)
			Lcd.setCursor(0,2)
			Lcd.message(News2)
			Lcd.setCursor(0,3)
			Lcd.message(News3)
			Shift = Shift + 1
			time.sleep(Delay)
		except KeyboardInterrupt:
			News = []
			Lcd.clear()
			os.system('clear')
			print('LCD Stopped.')
			sys.exit()

	Output_RSS()

if __name__ == '__main__':
	if len(sys.argv) > 1:
		Delay = int(sys.argv[1]) / 10.0
	else:
		Delay = 1
	Update_News(Feed)
	Output_RSS()
