import subprocess, time, sys, re, os
from Adafruit_CharLCDPlate import Adafruit_CharLCDPlate

Lcd = Adafruit_CharLCDPlate()
Lcd.begin(20, 2)
#Lcd.backlight(Lcd.RED)

Delay = 300
News = []
Feed = 'feeds.bbci.co.uk/news/rss.xml?edition=uk'

def Update_News(Url):
	News = []
	Args = ['curl' , Url]
	Proc = subprocess.Popen(Args, stdout=subprocess.PIPE)
	Out = Proc.stdout.read()
	Find = re.findall('<title>([\S ]*)</title>', Out)
	Find.pop(0)
	Find.pop(0)

	for A in Find:
		if A[:7] == 'VIDEO: ' or A[:7] == 'AUDIO: ' or A[:13] == 'In pictures: ' or A[:17] == 'Day in pictures: ':
			A = ''
		else:
			News.append(A)

	return News

def Output_RSS():
	News = Update_News(Feed)
	Shift = 0
	Max = 0
	Line1 = News[0]
	Line2 = News[1]
	Line3 = News[2]
	Line4 = News[3]
	print Line1, '\n', Line2, '\n'
	Day = time.strftime('%d')
	Suf = 'th'
	if Day == 1 or Day == 21 or Day == 31:
		Suf = 'st'
	elif Day == 2 or Day == 22:
		Suf = 'nd'
	elif Day == 3 or Day == 23:
		Suf = 'rd'
	else:
		Suf = 'th'
	if int(Day) < 10:
		Day = str(Day)[1:]
	Date =  time.strftime("%H:%M")
	Lcd.backlight(Lcd.RED)
	Line1 = Date + " 1)" + Line1 + "  ~~  3)" + Line3 + " "+ Date
	Line2 = Date + " 2)" + Line2 + "  ~~  4)" + Line4 + " "+ Date

	if len(Line2) > len(Line1):
		Max = len(Line2)
	else:
		Max = len(Line1)

	while Shift < Max:
		try:
			Lcd.clear()
			News1 = Line1[Shift:Shift+20]
			News2 = Line2[Shift:Shift+20]
			Lcd.setCursor(0,0)
			Lcd.message(News1)
			Lcd.setCursor(0,1)
			Lcd.message(News2)
			Shift = Shift + 1
			time.sleep(Delay)
		except KeyboardInterrupt:
			News = []
			Lcd.clear()
			os.system('clear')
			print('LCD Stopped.')
			sys.exit()

	Output_RSS()

if __name__ == '__main__':
	if len(sys.argv) > 1:
		Delay = int(sys.argv[1]) / 10.0
	else:
		Delay = 1
	Update_News(Feed)
	Output_RSS()
	sys.exit()			# If it somehow comes back from the recursive loop of death....
