import subprocess, time, sys, re, os, smbus
from Adafruit_CharLCDPlate import Adafruit_CharLCDPlate

Lcd = Adafruit_CharLCDPlate()
Lcd.begin(20, 4)
Bus = smbus.SMBus(1)
Delay = 300
News = []
global NewsShift
NewsShift = 0
Feed = 'feeds.bbci.co.uk/news/rss.xml?edition=uk'

Btn = (
( 0 , '1', 'Button 1'	),	# Select, Right, Down
( 1 , '2', 'Button 2'	),	# Up    , Left , Six
( 2 , '3', 'Button 3'	),	# Seven , Eight
( 3 , '4', 'Button 4'	),
( 4 , '5', 'Button 5'	),
( 5 , '6', 'Button 6'	),
( 6 , '7', 'Button 7'	),
( 7 , '8', 'Button 8'	)
)

def Update_News(Url):
	News = []
	Args = ['curl' , Url]
	Proc = subprocess.Popen(Args, stdout=subprocess.PIPE)
	Out = Proc.stdout.read()
	Find = re.findall('<title>([\S ]*)</title>', Out)
	Find.pop(0)
	Find.pop(0)

	for A in Find:
		if A[:6] == 'VIDEO:' or A[:6] == 'AUDIO:' or A[:12] == 'In pictures:' or A[:16] == 'Day in pictures:' or A[:17] == 'Week in pictures:' or A[:14] == 'Your Pictures:' or A[:16] == 'Only in England:' :
			A = ''
		else:
			News.append(A)

	return News

def Read(Addr, Bank):
	Out = Bus.read_byte_data(Addr, Bank)
	Out = '{:08b}'.format(Out)
	return Out


def Output_RSS():
	News = Update_News(Feed)
	Shift = 0
	Max = 0
	global NewsShift
	Line1 = News[0+NewsShift]
	Line2 = News[1+NewsShift]
	Line3 = News[2+NewsShift]
	if len(Line2) > len(Line1):
		Max = len(Line2)
	elif len(Line3) > len(Line2):
		Max = len(Line3)
	else:
		Max = len(Line1)

	print Line1, '\n', Line2, '\n', Line3, '\n'
	Day = time.strftime('%d')
	Suf = 'th'
	if Day == 1 or Day == 21 or Day == 31:
		Suf = 'st'
	elif Day == 2 or Day == 22:
		Suf = 'nd'
	elif Day == 3 or Day == 23:
		Suf = 'rd'
	else:
		Suf = 'th'
	if int(Day) < 10:
		Day = str(Day)[1:]
	Date =  time.strftime("{0}{1} %b,%H:%M Pg {2}".format(Day, Suf, NewsShift))
	while Shift < Max:
		try:
			for A in Btn:
				if Lcd.buttonPressed(A[0]):
					if A[0] == 7 and Shift >=1:
						NewsShift = NewsShift+1
						Shift = 0
						Output_RSS()
					if A[0] == 6 and Shift >=1 and NewsShift > 0:
						NewsShift = NewsShift-1
						Shift = 0
						Output_RSS()
					if A[0] == 0:
						Shift = 0
					if A[0] == 1 and Shift > 4:
						Shift = Shift - 5
					if A[0] == 1 and Shift < 4:
						Shift = 0
					if A[0] == 2:
						Shift = Shift + 3
					if A[0] == 3:
						Shift = Max - 20
					print("Button {0} Pressed!".format(A[1]) )
			Lcd.backlight(Lcd.RED)
			Lcd.clear()
			Lcd.setCursor(0,0)
			Lcd.message(Date)
			News1 = Line1[Shift:Shift+20]
			News2 = Line2[Shift:Shift+20]
			News3 = Line3[Shift:Shift+20]
			Lcd.setCursor(0,1)
			Lcd.message(News1)
			Lcd.setCursor(0,2)
			Lcd.message(News2)
			Lcd.setCursor(0,3)
			Lcd.message(News3)
			Shift = Shift + 1
			time.sleep(Delay)
		except KeyboardInterrupt:
			News = []
			Lcd.clear()
			os.system('clear')
			print('LCD Stopped.')
			sys.exit()

	Output_RSS()

if __name__ == '__main__':
	if len(sys.argv) > 1:
		Delay = int(sys.argv[1]) / 10.0
	else:
		Delay = 1
	Update_News(Feed)
	Output_RSS()
	sys.exit()			# If it somehow comes back from the recursive loop of death....
