from RPIO import PWM
import RPi.GPIO as GPIO
import time, os, sys, argparse, signal

PWM = PWM.Servo()

GPIO.setmode(11)	# BCM
Parser = argparse.ArgumentParser()
Parser.add_argument("section", help="Which section to illuminate ( A|B|C )")
Parser.add_argument("speed", help="Speed of the scrolling pattern in ms.")
Args = Parser.parse_args()

Sect = Args.section.upper()
Delay = int(Args.speed) / 100.0

def handler(frame, signal):
	for A in [17, 18, 27, 22, 23, 24, 25, 4, 28, 29, 30, 31]:
		try:
			GPIO.output(A, 0)
		except:
			pass
	exit(0)
signal.signal(signal.SIGINT, handler)

if Sect == "A":
	Pins = [17, 18, 27, 22, 23, 24, 25, 4]
elif Sect == "B":
	Pins = [28, 29, 30, 31]
elif Sect == "C":
	Pins = [17, 18, 27, 22, 23, 24, 25, 4, 28, 29, 30, 31]
else:
	Pins = [17, 27, 23, 25, 28, 30]

def Scroll():
	for A in Pins:
		GPIO.setup(A, 0)
	print "Scrolling"
	while True:
		for A in Pins:
			GPIO.output(A, 1)
			time.sleep(Delay)
			GPIO.output(A, 0)
		for A in range(len(Pins)-1, -1, -1):
			GPIO.output(Pins[A], 1)
			time.sleep(Delay)
			GPIO.output(Pins[A], 0)

Scroll()
