from Adafruit_PWM_Servo_Driver import PWM
import time, sys, signal, argparse

Parser = argparse.ArgumentParser()
Parser.add_argument("addr", help="HEX Address for PWM chip e.g. 0x20 / 0x40")
Parser.add_argument("start", help="Starting channel for Pattern / PWM", type=int)
Parser.add_argument("end", help="Last channel / end channel", type=int)
Parser.add_argument("delay", help="Delay between each 'Tick' / 100", type=float)
Parser.add_argument("--tail", help="Add a 'Tail' to the Pattern")
Args = Parser.parse_args()


Addr = int(Args.addr, 16)
R1 = Args.start
R2 = Args.end+1
Delay = Args.delay/100.0
ATail = Args.tail

print "\nAddr:  {}\nStart: {}\nEnd:   {}\nDelay: {}\nTail:  {}\n".format(Addr, R1, R2-1, Delay, ATail)

PWM = PWM(Addr, debug=False)

if R1 == 64 and R2 == 65:
	for A in range(0, 16):
		PWM.setPWM(A, 0, int(Delay*100))
	exit(0)

if ATail:
	if ATail.upper() == "FALSE":
		Tail = 0
	elif ATail.upper() == "TRUE":
		Tail = 50
else:
	Tail = 0

def handler(signal, frame):
	for A in range(0, 16):
		PWM.setPWM(A, 0, 0)
	exit(0)

signal.signal(signal.SIGTERM, handler)
signal.signal(signal.SIGINT, handler)

while True:
	for A in range(R1, R2):
		PWM.setPWM(A, 0, 1000)
		if A > R1:
			PWM.setPWM(A-1, 0, Tail*10)
		if A > R1+1:
			PWM.setPWM(A-2, 0, Tail)
		time.sleep(Delay)
		PWM.setPWM(A, 0, 0)
		if A > R1:
			PWM.setPWM(A-1, 0, 0)
		if A > R1+1:
			PWM.setPWM(A-2, 0, 0)


	for A in range(R2-1, R1, -1):
		PWM.setPWM(A, 0, 1000)
		if A < R2-1:
			PWM.setPWM(A+1, 0, Tail*10)
		if A < R2-2:
			PWM.setPWM(A+2, 0, Tail)
		time.sleep(Delay)
		PWM.setPWM(A, 0, 0)
		if A < R2-1:
			PWM.setPWM(A+1, 0, 0)
		if A < R2-2:
			PWM.setPWM(A+2, 0, 0)
